Prevent parent issue from being closed if a child issue is open
Category: Issues Estimated time: 0.00 hour
Target version: 3.4.0

Resolution: Fixed

Description

I am able to close a parent issue while its Child issues are yet not closed/rejected, ideally it should not let a use to close a Parent
issue, until all it's child issues are not closed.

Related issues:

Related to Redmine - Feature #13585: Make sub-task inherit the properties of ... New

Related to Redmine - Defect #27974: Issue-state can't set to done if state of... Closed

Related to Redmine - Feature #28492: Option not to block closing a parent iss... New

Related to Redmine - Feature #31589: Show warning and the reason when the iss... Closed

Related to Redmine - Feature #31321: Option not to block closing a parent iss... Closed

Has duplicate Redmine - Feature #12956: Warning "parent issue is closed" Closed

Has duplicate Redmine - Feature #18212: The status of parent issue could be c... Closed

Has duplicate Redmine - Feature #5462: Blocking issues to be closed which hav... Closed 2010-05-07

Associated revisions

Revision 16108 - 2016-12-21 10:09 - Jean-Philippe Lang

Prevent parent issue from being closed if a child issue is open (#10989).

History

#1 - 2012-05-25 19:18 - Jean-Philippe Lang
- Tracker changed from Defect to Feature

- Subject changed from Parent issue can be closed, while it's child issues are still open to Prevent parent issue from being closed, while it's child
issues are still open

- Assignee deleted (Azamat Hackimov)

- Priority changed from High to Normal

#2 - 2014-10-28 04:29 - Toshi MARUYAMA

- Has duplicate Feature #12956: Warning "parent issue is closed" added

#3 - 2014-10-28 04:31 - Toshi MARUYAMA

- Has duplicate Feature #18212: The status of parent issue could be changed to closed before all of the sub issues’ status are changed to closed
added

#4 - 2015-04-16 08:28 - Ami Desai

+1

#5 - 2016-08-26 02:11 - Go MAEDA

| think the behavior is logical and this feature is really needed.

#18212 has a patch.

#6 - 2016-08-31 00:55 - Marius BALTEANU

This means also that we shouldn't be able to add to a new/open issue a parent which is already closed?
#7 - 2016-09-20 10:20 - Marius BALTEANU
- File cant_close_before_sub_issues_closed.patch added
| made a patch (inspired from #18212) with tests that implements this feature request.

@Go MAEDA, | still think that in order to implement this completely, we should not allow to set for a new/open issue a parent which is already closed.
I'm waiting for your feedback (or other Redmine contributors) in order to include also this change in the patch.

#8 - 2016-09-20 14:11 - Toshi MARUYAMA
- Related to Feature #13585: Make sub-task inherit the properties of parent added

#9 - 2016-09-20 14:11 - Toshi MARUYAMA
- Related to deleted (Feature #13585: Make sub-task inherit the properties of parent)

#10 - 2016-09-20 14:12 - Toshi MARUYAMA
- Related to Feature #13585: Make sub-task inherit the properties of parent added

#11 - 2016-09-20 14:13 - Toshi MARUYAMA

- Has duplicate Feature #5462: Blocking issues to be closed which have open subtasks added

#12 - 2016-09-20 14:29 - Toshi MARUYAMA
Marius BALTEANU wrote:

I made a patch (inspired from #18212) with tests that implements this feature request.

LGTM.
| have some questions.
What happens if opened child issues which user cannot see (private/visibility)?
error_can_not_close_issue_with_open_subtasks: "An issue with open subtasks cannot be closed"
Would it better "An issue" -> "The issue"?
@Go MAEDA, | still think that in order to implement this completely, we should not allow to set for a new/open issue a parent which is already

closed. I'm waiting for your feedback (or other Redmine contributors) in order to include also this change in the patch.

| think this would better in separate issue.
#13 - 2016-09-20 18:05 - Marius BALTEANU
Toshi MARUYAMA wrote:
What happens if opened child issues which user cannot see (private/visibility)?

The user will receive the same error message and | think that is the correct behavior because any open subtask means work to do (from my point of
view).
If you have the following scenario:

¢ |ssue with 4 subtasks

e Two are visible to my role

e Other two are visible to another role.

Closing my subtasks doesn't means that the parent issue can be closed, it means only that | made my piece of work. If you think that it'll be confusing
for the users, we can improve the error message.

Would it better "An issue" -> "The issue"?
| took some internal feedback and the new proposal is "You cannot close an issue with open subtasks.". Let me know what do you think in order to
update the patch.

@Go MAEDA, | still think that in order to implement this completely, we should not allow to set for a new/open issue a parent which is
already closed. I'm waiting for your feedback (or other Redmine contributors) in order to include also this change in the patch.
| think this would better in separate issue.

Agree, I'll open a new issue.

#14 - 2016-10-20 12:20 - Toshi MARUYAMA

- Target version set to Candidate for next major release

#15 - 2016-10-20 12:23 - Toshi MARUYAMA
Marius BALTEANU wrote:

Let me know what do you think in order to update the patch.

Please update the patch.

#16 - 2016-10-20 14:53 - Marius BALTEANU

- File cant_close_before_sub_issues_closed v2.patch added

Here it is.

#17 - 2016-11-16 13:15 - Toshi MARUYAMA

- Target version changed from Candidate for next major release to 3.4.0

#18 - 2016-12-16 10:13 - Marius BALTEANU

- File cant_close_before_sub_issues_closed v3.patch added

Fixed the expected error message in the test.

#19 - 2016-12-21 10:13 - Jean-Philippe Lang

- Subject changed from Prevent parent issue from being closed, while it's child issues are still open to Prevent parent issue from being closed if a child
issue is open

- Status changed from New to Closed
- Assignee set to Jean-Philippe Lang

- Resolution set to Fixed

Added in r16108. It prevents a parent task with open subtasks from being closed and a subtask of a closed issue from being reopened (in the same
way as blocked issues were currently handled). It also prevents an open issue to be set as a subtask of a closed parent issue.

#20 - 2016-12-21 10:16 - Jean-Philippe Lang

| took some internal feedback and the new proposal is "You cannot close an issue with open subtasks."

| chose to use "An open issue cannot be attached to a closed parent task" to be consistent with other validation messages (eg. "An issue cannot be
linked to one of its subtasks").

#21 - 2016-12-21 10:42 - Marius BALTEANU

Thanks for implementing this. The new error message is fine for me.

#22 - 2018-01-13 01:53 - Go MAEDA

- Related to Defect #27974: Issue-state can't set to done if state of one subissue is not set to done added

#23 - 2018-08-07 17:23 - Go MAEDA
- Related to Feature #27864: Subtasks inherit parent settings during copy added

#24 - 2018-08-07 17:24 - Go MAEDA
- Related to deleted (Feature #27864: Subtasks inherit parent settings during copy)
#25 - 2018-08-07 17:24 - Go MAEDA

- Related to Feature #28492: Option not to block closing a parent issue when it has open subtask(s) added

#26 - 2019-06-19 07:54 - Go MAEDA
- Related to Feature #31589: Show warning and the reason when the issue cannot be closed because of open subtasks or blocking open issue(s)
added

#27 - 2019-06-19 07:55 - Go MAEDA

- Related to Feature #31321: Option not to block closing a parent issue when its subtask is open added

Files

cant_close_before_sub_issues_closed.patch 2.79 KB 2016-09-20 Marius BALTEANU
cant_close_before_sub_issues_closed_v2.patch 2.81 KB 2016-10-20 Marius BALTEANU
cant_close_before_sub_issues_closed_v3.patch 2.81 KB 2016-12-16 Marius BALTEANU
